(define rules '((primitiverule (condition ((formula A (PHI1 and PHI2)))) 
  
 (add ((formula A PHI1) (formula A PHI2))))


(primitiverule (condition ((world A))) 
  
 (add ((A link 1 A) (A link 2 A) (A link 3 A))))


(primitiverule (condition ((formula A (2 thinks reg2)))) 
  
 (add ((formula A reg2))))


(primitiverule (condition ((formula A (2 thinks (not (not reg2)))))) 
  
 (add ((formula A reg2))))


(primitiverule (condition ((formula A (3 thinks reg3)))) 
  
 (add ((formula A reg3))))


(primitiverule (condition ((formula A (3 thinks (not (not reg3)))))) 
  
 (add ((formula A reg3))))


(primitiverule (condition ((formula A (PHI1 imply PHI2)))) 
  
 (add ((formula A ((not PHI1) or PHI2)))))


(primitiverule (condition ((formula A (not (PHI1 imply PHI2))))) 
  
 (add ((formula A (PHI1 and (not PHI2))))))


(primitiverule (condition ((formula A (PHI1 equiv PHI2)))) 
  
 (add ((formula A ((PHI1 imply PHI2) and (PHI2 imply PHI1))))))


(primitiverule (condition ((formula A (not (PHI1 and PHI2))))) 
  
 (add ((formula A ((not PHI1) or (not PHI2))))))


(primitiverule (condition ((formula A (not (PHI1 equiv PHI2))))) 
  
 (add ((formula A (((not PHI1) and PHI2) or (PHI1 and (not PHI2)))))))


(primitiverule (condition ((formula A (not (PHI1 or PHI2))))) 
  
 (add ((formula A ((not PHI1) and (not PHI2))))))


(primitiverule (condition ((formula A (not (not PHI1))))) 
  
 (add ((formula A PHI1))))


(primitiverule (condition ((formula A (not PHI))(formula A PHI))) 
  
 (add ((formula A bottom))))


(primitiverule (condition ((formula A bottom))) 
  
 (add ((halt)) ) )


(primitiverule (condition ((formula A (not top)))) 
  
 (add ((halt)) ) )


(primitiverule (condition ((formula B (p PHI))(formula B (p PSI)))) 
 (suchthat (diff? PSI PHI))
 (add ((halt)) ) )


(primitiverule (condition ((formula (A B) L))) 
(suchthat (and (literal? L) (diff? L 'ok) (diff? L '(not ok)))) 
 (add ((formula A L) (world A))))


(primitiverule (condition ((formula A (AGT knows PHI))(A link AGT B)(world B))) 
  
 (add ((formula B PHI))))


(primitiverule (condition ((formula A (not (AGT knows PHI))))) 
  
 (add ((formula A (AGT thinks (not PHI))))))


(primitiverule (condition ((formula A (not (AGT thinks PHI))))) 
  
 (add ((formula A (AGT knows (not PHI))))))


(primitiverule (condition ((formula A (PHI1 or PHI2))(formula A (not PHI1)))) 
  
 (add ((formula A PHI2))))


(primitiverule (condition ((formula A (PHI1 or PHI2))(formula A (not PHI2)))) 
  
 (add ((formula A PHI1))))


(primitiverule (condition ((formula A PHI)(formula A (PHI imply PSI)))) 
  
 (add ((formula A PSI))))


(primitiverule (condition ((formula A ((not PHI1) or PHI2))(formula A (PHI1)))) 
  
 (add ((formula A PHI2))))


(primitiverule (condition ((formula A (PHI1 or (not PHI2)))(formula A PHI2))) 
  
 (add ((formula A PHI1))))


(primitiverule (condition ((formula (A B) ok)(formula B (p PHI)))) 
  
 (add ((formula A PHI) (world A))))


(primitiverule (condition ((formula (A B) (not ok))(formula B (p PHI)))) 
  
 (add ((formula A (not PHI)) (world A))))


(primitiverule (condition ((formula (A B) (AGT thinks PHI)))) 
  
 (add ((formula (C D) PHI) (formula (C D) ok) (A link AGT C) ((A B) link AGT (C D)) (B link AGT D) (world (C D)) (world A) (world C) (world B) (world D))))


(primitiverule (condition ((formula A (AGT thinks PHI)))) 
(suchthat (literal? A)) 
 (add ((formula B PHI) (A link AGT B) (world B))))


(primitiverule (condition ((formula A (PHI1 or PHI2)))) 
  
 (add-nondeterminist ((formula A PHI1))((formula A PHI2))))


(primitiverule (condition ((C link AGT A)(D link AGT B)(world C)(world A)(world D)(world B)(world (C D)))) 
  
 (add-nondeterminist ((world (A B)) ((C D) link AGT (A B)) (formula (A B) ok))((world (A B)) (formula (A B) (not ok)))))


))

