; (load "machinestate.scm")
; (load "lotreclight.scm")
; (load "element-generator.scm")



; (module-export continue!)
; (module-export start!)
; (module-export get-graph-state)
; (module-export get-graph-nd-queue-top)
; (module-export state)





					  
					  
					  
					  
(define state '())
(define current-formula '())
(define couplerulesigma '())

(define (continue! rules)
  (begin 
	
        (set! state (couplerulesigma-apply couplerulesigma state))
		(set! state (state-clean rules state))
	(set! couplerulesigma (rules-firstrule-get-future-couplerulesigmatoapply rules state))))

	
	
	
(define (finish! rules)
	(if (isunsat?)
		'unsat
		(if (issat?)
			'sat
			(begin
			    (continue! rules)
				(finish! rules)))))
		

(define (isunsat?) (equal? state #f))
(define (issat?) (equal? couplerulesigma #f))





(define (start! rules setofterms)
  (begin (nd-queue-init)
       ;  (set! state (state-clean rules (machinestate-create setofterms rules)))
         (set! state (machinestate-create setofterms rules))
		 (set! couplerulesigma (rules-firstrule-get-future-couplerulesigmatoapply rules state))))




;(executewithformula! rules '( ((box (diamond (p or q)) )  and  (box (diamond (not p)  )))  and (diamond (box (not r)))))
(define (executewithformula! rules phi)
 (begin
	(startwithformula! rules phi)
	(finish! rules)))
	
(define (executewithsetofterms! rules setofterms)
 (begin
	(start! rules setofterms)
	(finish! rules)))

(define (get-graph-state) (graph-make (machinestate-set-get state)))
(define (get-graph-nd-queue-top) (graph-make (machinestate-set-get (nd-queue-top))))