(define rules '((primitiverule (condition ((world A)(formula A (lf L (PHI1 and PHI2))))) 
  
 (add ((formula A (lf L PHI1)) (formula A (lf L PHI2)))))


(primitiverule (condition ((world A)(formula A (lf L (PHI1 imply PHI2))))) 
  
 (add ((formula A (lf L ((not PHI1) or PHI2))))))


(primitiverule (condition ((world A)(formula A (lf L (not (PHI1 imply PHI2)))))) 
  
 (add ((formula A (lf L (PHI1 and (not PHI2)))))))


(primitiverule (condition ((world A)(formula A (lf L (PHI1 equiv PHI2))))) 
  
 (add ()))


(primitiverule (condition ((world A)(formula A (lf L (not (PHI1 and PHI2)))))) 
  
 (add ((formula A (lf L ((not PHI1) or (not PHI2)))))))


(primitiverule (condition ((world A)(formula A (lf L (not (PHI1 equiv PHI2)))))) 
  
 (add ((formula A (lf L ((not (PHI1 imply PHI2)) or (not (PHI2 imply PHI1))))))))


(primitiverule (condition ((world A)(formula A (lf L (not (PHI1 or PHI2)))))) 
  
 (add ((formula A (lf L (not (PHI1٧ PHI2)))) (formula A (lf L ((not PHI1) and (not PHI2)))))))


(primitiverule (condition ((world A)(formula A (lf L (not (not PHI1)))))) 
  
 (add ((formula A (lf L PHI1)))))


(primitiverule (condition ((world A)(formula A (lf L (not PHI)))(formula A (lf L PHI)))) 
  
 (add ((formula A (lf L bottom)))))


(primitiverule (condition ((world A)(formula A (lf L bottom)))) 
  
 (add ((halt)) ) )


(primitiverule (condition ((world A)(world B)(formula B (lf L (box AGT PHI))))) 
  
 (add ((A link AGT A))))


(primitiverule (condition ((world A)(world B)(formula B (lf L (diamond AGT PHI))))) 
  
 (add ((A link AGT A))))


(primitiverule (condition ((world A)(formula A (lf L (not (diamond AGT PHI)))))) 
  
 (add ((formula A (lf L (box AGT (not PHI)))))))


(primitiverule (condition ((world A)(formula A (lf L (not (box AGT PHI)))))) 
  
 (add ((formula A (lf L (diamond AGT (not PHI)))))))


(primitiverule (condition ((world A)(formula A (lf L (diamond AGT PHI))))) 
  
 (add ((world B) (formula B (lf L PHI)) (A link AGT B))))


(primitiverule (condition ((world A)(formula A (lf L (box AGT PHI)))(world B)(A link AGT B))) 
  
 (add ((formula B (lfbox L PHI)))))


(primitiverule (condition ((world A)(formula A (lf L (PHI1 or PHI2))))) 
  
 (add-nondeterminist ((formula A (lf L PHI1)))((formula A (lf L PHI2)))))


(primitiverule (condition ((world A)(world B)(A link AGT B))) 
  
 (add ((B link AGT A))))


(primitiverule (condition ((world A)(world B)(world C)(A link AGT B)(B link AGT C))) 
  
 (add ((A link AGT C))))


(primitiverule (condition ((world A)(formula A (lfbox () PHI)))) 
  
 (add ((formula A (lf () PHI)))))


(primitiverule (condition ((world A)(formula A (lfbox L PHI)))) 
 (suchthat (not (set-empty? L)))
 (add-nondeterminist ((formula A (lf L PHI)))((formula A (lfbox (unquote (cdr (quote L))) (not (unquote (car (quote L)))))))))


(primitiverule (condition ((world A)(formula A (lf L PHI)))) 
(suchthat (not (set-empty? L))) 
 (add ((formula A (lf (unquote (cdr (quote L))) (unquote (car (quote L))))))))


(primitiverule (condition ((world A)(formula A (lf L (anndiamond PSI PHI))))) 
  
 (add ((formula A (lf (unquote (cons (quote PSI) (quote L))) PHI)))))


(primitiverule (condition ((world A)(formula A (lf L (annbox PSI PHI))))) 
  
 (add-nondeterminist ((formula A (lf L (not PSI))))((formula A (lf (unquote (cons (quote PSI) (quote L))) PHI)))))


(primitiverule (condition ((world A)(formula A (lf L (not (annbox PSI PHI)))))) 
  
 (add ((formula A (lf L (anndiamond PSI (not PHI)))))))


(primitiverule (condition ((world A)(formula A (lf L (not (anndiamond PSI PHI)))))) 
  
 (add ((formula A (lf L (not (annbox PSI (not PHI))))))))


(primitiverule (condition ((world A)(formula A (lf L P)))) 
(suchthat (proposition? P)) 
 (add ((formula A (lf () P)))))


(primitiverule (condition ((world A)(formula A (lf L (not P))))) 
(suchthat (proposition? P)) 
 (add ((formula A (lf () (not P))))))


(primitiverule (condition ((world A))) 
  
 (add ((A link 1 A))))


(primitiverule (condition ((world A))) 
  
 (add ((A link 2 A))))


))

(define examples '(
((formula n1 (lf () ((not (box 1 p)) and (annbox p (box 1 p))))))

((formula n1 (lf () (annbox p q))))

))